package Aselector;
our @ISA=('Baseobject' );
use CGI;
use URI;
use utf8;
use strict;
use warnings  FATAL=> 'all';
use Aselect::Client;

sub new {
  my $pkg = shift;
  my $self = bless (new Baseobject(@_),$pkg);

  $self->needs([ qw (cgi aselectAppId)]);
  $self->fields(@_);
  $self->checkneeds();

  return $self if ($self->error());
  $self->{result} = eval {
    $self->aselect();
  };
  $self->error($@) if ($@);

  return $self;
}

sub aselect {
  my $self = shift;
  my $cgi = $self->{fields}->{cgi};
  my $app = $self->{fields}->{aselectAppId};
  # concatenate path_info to the url
  my $url = $cgi->url . $cgi->path_info;
  my $ticket = $cgi->cookie('aselect');
  my $uri = URI->new($url);
  my %query = %{$cgi->Vars()};

  # remove the aselectstuff from the userquery
  delete $query{'a-select-server'};
  delete $query{'rid'};
  delete $query{'aselect_credentials'};
  $uri->query_form(\%query);

  if(defined $ticket) {
    # Step 3. User was here before, check ticket and proceed.
    eval {
      my ($uid, $org) = aselect_verify_ticket($ticket);
      $self->{uid} = $uid;
      $self->{org} = $org;
    };
    return 1 unless $@;
    warn "aselect_verify_ticket: $@";
  }

  my $cred = $cgi->param('aselect_credentials');
  if(defined $cred) {
    # Step 2. Authentication provider provided credentials, verify these.
    my $rid = $cgi->param('rid');
    unless (defined $rid) {
      # fixme: eval/die flow is fuzzy
      my $shit = "no rid param"; $self->error($shit); die $shit;
    }
    eval {
      # Redirect to application after verification.
      $ticket = aselect_verify_credentials($rid, $cred);
      my $cookie = $cgi->cookie(-name => 'aselect',
				-value => $ticket);

      print $cgi->header(-status => 302,
			 -cookie => $cookie,
			 -charset=>'utf-8',
			 -Location=> $uri->as_string
	  )
    };
    return undef unless $@;
    $self->error("aselect_verify_credentials: $@");
  }
  # Step 1. Redirect to authentication provider
  my $sso = aselect_authenticate($app, $uri->as_string);
  print $cgi->header(-Location => $sso,
		     -status => 302,
		     -charset=>'utf-8' );
  return undef;
}
